# -*- coding: utf-8 -*-

from django import forms


class ModelFormWithFrozenField(forms.ModelForm):
    def __init__(self, *args, **kwargs):
        forzeField = kwargs.pop("forzeField", [])
        super(ModelFormWithFrozenField, self).__init__(*args, **kwargs)
        self._forzeField = forzeField
        for field in self._forzeField:
            self.fields[field].required = False
            self.fields[field].disabled = True
            self.fields[field].widget.attrs["readonly"] = True
            self.fields[field].widget.attrs["disabled"] = True

    def clean(self):
        cleaned_data = super(ModelFormWithFrozenField, self).clean()
        for field in self._forzeField:
            if field in self.initial:
                cleaned_data[field] = self.initial[field]
            else:
                cleaned_data[field] = getattr(self.instance, field)
        return cleaned_data
